package com.sillycycle.bagleyd.panex.view;

/*
 * @(#)PanexDraw.java
 *
 * Copyright 1994 - 2022  David A. Bagley, bagleyd AT verizon.net
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/*import java.awt.Canvas;
import java.awt.Color;
import java.awt.Font;
import java.awt.Point;
import java.awt.Graphics;
import java.awt.Image;*/

//import android.graphics.Canvas;
import android.graphics.Point;

import com.sillycycle.bagleyd.util.Colour;
import com.sillycycle.bagleyd.util.Graphics;
import com.sillycycle.bagleyd.panex.PanexCanvas;
import com.sillycycle.bagleyd.panex.model.PanexFormat;
import com.sillycycle.bagleyd.panex.model.PanexTile;

/**
 * The <code>PanexDraw</code> class does all the basic graphics for
 * <code>PanexApp</code> class.
 *
 * @author	David A. Bagley
 * @author	bagleyd AT verizon.net
 * @author	https://www.sillycycle.com/panex.html
 */

public class PanexDraw {
	private PanexFormat model;
	private PanexGeometry geo;
	private Graphics graphics;

	// .9.png may be the way to go here
	/*Image       bufferedFrameImage = null;
	Image[]     bufferedStartImage = new Image[2];
	Graphics    bufferedFrameGraphics = null;
	Graphics[]  bufferedStartGraphics = new Graphics[2];*/
	private Point[] trapazoidUnit = new Point[5];

	/*static void fill3DRect(Canvas g, int x, int y, int width, int height,
		boolean raised, boolean upDown) {

		c = g.getColor();
		int brighter = brighter(c);
		int darker = c.darker();

		if (!raised) {
			g.setColor(darker);
		}
		if (upDown) {
			g.fillRect(x + 1, y, width - 2, height);
			g.setColor(raised ? brighter : darker);
			g.drawLine(x, y, x + width - 1, y);
			g.setColor(raised ? darker : brighter);
			g.drawLine(x, y + height - 1, x + width - 1, y + height - 1);
		} else {
			g.fillRect(x, y + 1, width, height - 2);
			g.setColor(raised ? brighter : darker);
			g.drawLine(x, y, x, y + height - 1);
			g.setColor(raised ? darker : brighter);
			g.drawLine(x + width - 1, y, x + width - 1, y + height - 1);
		}
		g.setColor(c);
	}*/

	public PanexDraw(PanexFormat model, PanexGeometry geo) {
		this.model = model;
		this.geo = geo;
		/*bufferedFrameImage = canvas.createImage(geo.getCoreSize().x, geo.getCoreSize().y);
		bufferedFrameGraphics = bufferedFrameImage.getGraphics();
		bufferedStartImage[0] = canvas.createImage(geo.getCoreSize().x, geo.getCoreSize().y);
		bufferedStartImage[1] = canvas.createImage(geo.getCoreSize().x, geo.getCoreSize().y);
		bufferedStartGraphics[0] = bufferedStartImage[0].getGraphics();
		bufferedStartGraphics[1] = bufferedStartImage[1].getGraphics();*/
		trapazoidUnit[0] = new Point(0, 0);
		trapazoidUnit[1] = new Point(1, 1);
		trapazoidUnit[2] = new Point(-3, 0);
		trapazoidUnit[3] = new Point(1, -1);
		trapazoidUnit[4] = new Point(2, 0);
		this.graphics = new Graphics(PanexCanvas.getCanvas(), PanexCanvas.getPaint());
	}

	public Graphics getGraphics() {
		return graphics;
	}

	public void drawFrame(boolean show, boolean border) {
		Graphics g = getGraphics();

		if (g == null)
			return;
		/*try*/ {
			drawFrame(g, show, border);
		/*} finally {
			g.dispose();*/
		}
	}

	public void drawSlots() {
		Graphics g = getGraphics();

		if (g == null)
			return;
		/*try*/ {
			drawSlots(g);
		/*} finally {
			g.dispose();*/
		}
	}

	/*void copyImage(Graphics g, Image i, int dX, int dY, int sX, int sY,
			int imageWidth, int imageHeight) {
		g.drawImage(i, dX, dY, dX + imageWidth, dY + imageHeight,
			sX, sY, sX + imageWidth, sY + imageHeight, canvas);
	}*/

	private static void fill3DRect(Graphics g, int x, int y, int width, int height,
			boolean raised) {
		int c = g.getColor();
		int brighter = (new Colour(c)).brighter();
		int darker = (new Colour(c)).darker();

		if (!raised) {
			g.setColor(darker);
		}
		g.fillRect(x + 1, y + 1, width - 2, height - 2);
		g.setColor(raised ? brighter : darker);
		g.drawLine(x, y, x, y + height - 1);
		g.drawLine(x + 1, y, x + width - 2, y);
		if (width > 2)
			g.drawLine(x + 1, y, x + 1, y + height - 1);
		if (height > 2)
			g.drawLine(x + 2, y + 1, x + width - 1, y + 1);
		g.setColor(raised ? darker : c);
		g.drawLine(x + 1, y + height - 1, x + width - 1, y + height - 1);
		g.drawLine(x + width - 1, y, x + width - 1, y + height - 2);
		if (height > 2)
			g.drawLine(x + 2, y + height - 2, x + width - 2, y + height - 2);
		if (width > 2)
			g.drawLine(x + width - 2, y + 1, x + width - 2, y + height - 3);
		g.setColor(c);
	}

	private static void drawShadow(Graphics g, int startX, int startY,
			int sizeX, int sizeY) {
		g.drawLine(startX, startY, startX + sizeX - 1, startY);
		g.drawLine(startX, startY, startX, startY + sizeY - 1);
	}

	private static int SIGN(int a) {
		return ((a < 0) ? -1 : 1);
	}

	private void drawPyramid(Graphics g, int color, int i, int j, int size,
			int offsetPosition) {
		Point[] trapazoidList = new Point[5];
		int k, sizey;

		if (color < 0)
			return;
		k = geo.getDelta().x + i * geo.getPos().x + geo.getFrameOffset().x +
			geo.getTileSize().x / 2 + offsetPosition + 1;
		trapazoidList[0] = new Point((size * SIGN(trapazoidUnit[4].x) *
				geo.getTileSize().x / (model.getTiles() + 1)) / 2 + k,
				j * geo.getPos().y + geo.getDelta().y +
				geo.getFrameOffset().y + offsetPosition + 2);
		sizey = geo.getTileSize().y - 4;
		if (sizey <= 0) {
			trapazoidList[0].y += sizey;
			sizey = 1;
		}
		for (int l = 1; l <= 4; l++) {
			trapazoidList[l] = new Point();
			if (java.lang.Math.abs(trapazoidUnit[l].x) == 3)
				trapazoidList[l].x = (size + 1) *
				SIGN(trapazoidUnit[l].x) *
				geo.getTileSize().x / (model.getTiles() + 1) +
				trapazoidList[l - 1].x;
			else if (java.lang.Math.abs(trapazoidUnit[l].x) == 2)
				trapazoidList[l].x = size *
				SIGN(trapazoidUnit[l].x) *
				geo.getTileSize().x / (model.getTiles() + 1) +
				trapazoidList[l - 1].x;
			else
				trapazoidList[l].x = geo.getTileSize().x /
				(2 * (model.getTiles() + 1)) +
				trapazoidList[l - 1].x;
			trapazoidList[l].y = sizey *
				trapazoidUnit[l].y +
				trapazoidList[l - 1].y;
		}
		int trapazoidColor, fontColor;
		if (geo.getMono()) {
			if ((offsetPosition != 0) ^ geo.getReverse()) {
				trapazoidColor = geo.getTileColor();
				fontColor = new Colour(geo.getBackground()).darker2();
			} else {
				trapazoidColor = new Colour(geo.getBackground()).darker2();
				fontColor = geo.getTileColor();
			}
		} else {
			if ((geo.getPyramidColor(color) == new Colour(geo.getBackground()).darker2()) &&
					offsetPosition != 0) {
				trapazoidColor = geo.getTileColor();
			} else if ((geo.getPyramidColor(color) == geo.getTileColor()) &&
					offsetPosition == 0) {
				trapazoidColor = new Colour(geo.getBackground()).darker2();
			} else {
				trapazoidColor = geo.getPyramidColor(color);
			}
			fontColor = trapazoidColor;
		}
		g.setColor(trapazoidColor);
		g.fillPolygon(trapazoidColor, trapazoidColor, trapazoidList); /* 4 */

		if (geo.getMono()) {
			g.setColor(fontColor);
			/*int offsetX = -1, offsetY, fontSize;
			// TODO need font for mono
			fontSize = java.lang.Math.min(geo.getTileSize().x,
				geo.getTileSize().y) / 2;
			g.setFont(new Font("arial", Font.PLAIN, fontSize));
			offsetX += -fontSize / 3;
			offsetY = fontSize / 3;
			g.drawString(Character.toString(geo.getPyramidNames().charAt(color)),
				k + offsetX,
				trapazoidListY[0] + geo.getTileSize().y / 2 + offsetY);*/
		}
	}

	private static void fillRectClip(Graphics g, int dx, int dy, int sx, int sy,
			int wdx, int wdy, int wsx, int wsy) {
		/* w is the clipping window */
		if (dx + sx < wdx || dx > wdx + wsx ||
				dy + sy < wdy || dy > wdy + wsy ||
				sx <= 0 || sy <= 0 || wsx <= 0 || wsy <= 0) {
			return;
		}
		int ndx = wdx, nsx = wsx, ndy = wdy, nsy = wsy;

		if (dx > wdx) {
			ndx = dx;
			nsx = wsx - dx + wdx;
		}
		if (dy > wdy) {
			ndy = dy;
			nsy = wsy - dy + wdy;
		}
		if (ndx + nsx > dx + sx) {
			nsx = sx + dx - ndx;
		}
		if (ndy + nsy > dy + sy) {
			nsy = sy + dy - ndy;
		}
		g.fillRect(ndx, ndy, nsx, nsy);
	}

	public void drawSlot(Graphics g, int stack, int x, int y,
			int width, int height) {
		int sizex = geo.getTileSize().x / 3;
		int sizey = geo.getTileSize().y / 3;
		boolean algorithme = (model.getMode() == PanexFormat.Modes.ALGORITHME.ordinal());
		boolean panex = (model.getMode() == PanexFormat.Modes.PANEX.ordinal());

		g.setColor(geo.getBackground());
		g.fillRect(x, y, width, height);
		g.setColor(new Colour(geo.getBackground()).darker());
		fillRectClip(g, (algorithme) ? 0 : (sizex + geo.getDelta().x +
			geo.getFrameOffset().x),
			geo.getDelta().y / 2 + geo.getFrameOffset().y + sizey,
			(algorithme) ? (geo.getFrameSize().x - 2 * geo.getFrameOffset().x) :
			(sizex + (PanexFormat.MAX_COLUMNS - 1) * geo.getPos().x),
			sizey,
			x, y, width, height);
		if (panex || model.getTiles() != 1) {
			fillRectClip(g, sizex + geo.getDelta().x +
				geo.getFrameOffset().x + stack * geo.getPos().x,
				geo.getDelta().y / 2 + geo.getFrameOffset().y + sizey,
				sizex,
				model.getSlots() * geo.getPos().y + geo.getDelta().y -
				1 - 2 * sizey,
				x, y, width, height);
			fillRectClip(g, sizex + geo.getDelta().x +
				geo.getFrameOffset().x + geo.getPos().x,
				geo.getDelta().y / 2 + geo.getFrameOffset().y + sizey,
				sizex,
				model.getSlots() * geo.getPos().y + geo.getDelta().y -
				1 - 2 * sizey,
				x, y, width, height);
		}
	}

	public void drawTile(Graphics g, int i, int j, boolean erase,
			int pressedOffset, int offsetX, int offsetY) {
		int dx, dy;
		int tileI, tileJ;
		boolean algorithme = (model.getMode() == PanexFormat.Modes.ALGORITHME.ordinal());
		boolean panex = (model.getMode() == PanexFormat.Modes.PANEX.ordinal());
		PanexTile tile = model.getColumn(i).getTileAtPosition(j);

		if (i < 0 || j < 0 || tile == null) {
			System.err.println("drawTile: i = " + i + ", j = " + j);
			return;
		}
		tileI = model.getColumn(i).getTileAtPosition(j).getColor();
		tileJ = model.getColumn(i).getTileAtPosition(j).getNumber();
		dx = geo.cartesianX(i) + pressedOffset + offsetX;
		dy = geo.cartesianY(j) + pressedOffset + offsetY;
		if (g == null)
			return;
		if (erase) {
			/* Draw Slots */
			g.setColor(geo.getBackground());
			g.fillRect(dx, dy,
				geo.getTileSize().x + 1,
				geo.getTileSize().y + 1 - pressedOffset);
			g.setColor(new Colour(geo.getBackground()).darker());
			if (j == 0) {
				if (i == 0 && !algorithme) {
					g.fillRect(dx + geo.getTileSize().x / 3,
						dy + geo.getTileSize().y / 3 - 1 -
						pressedOffset,
						2 * geo.getTileSize().x / 3 + 2,
						geo.getTileSize().y / 3);
				} else if (i == PanexFormat.MAX_COLUMNS - 1 && !algorithme) {
					g.fillRect(dx,
						dy + geo.getTileSize().y / 3 - 1 -
						pressedOffset,
						2 * geo.getTileSize().x / 3 - 1,
						geo.getTileSize().y / 3);
				} else {
					g.fillRect(dx,
						dy + geo.getTileSize().y / 3 - 1 -
						pressedOffset,
						geo.getTileSize().x + 1,
						geo.getTileSize().y / 3);
				}
				if (panex || model.getTiles() != 1) {
					g.fillRect(dx + geo.getTileSize().x / 3 - pressedOffset,
						dy + geo.getTileSize().y / 3 - 1,
						geo.getTileSize().x / 3,
						geo.getTileSize().y - geo.getTileSize().y / 3 +
						2 - pressedOffset);
				}
			} else if (j == model.getSlots() - 1) {
				g.fillRect(dx + geo.getTileSize().x / 3 - pressedOffset,
					dy - pressedOffset,
					geo.getTileSize().x / 3,
					2 * geo.getTileSize().y / 3 + 2);
			} else {
				g.fillRect(dx + geo.getTileSize().x / 3 - pressedOffset,
					dy - pressedOffset,
					geo.getTileSize().x / 3,
					geo.getTileSize().y + pressedOffset + 1);
			}
			return;
		}
		/*copyImage(g, bufferedStartImage[pressedOffset],
			dx, dy, sx, sy, geo.getTileSize().x, geo.getTileSize().y);*/
		drawBufferedTile(g, i, j, pressedOffset, tileI, tileJ);
	}

	public void drawTile(int i, int j, boolean erase,
			int pressedOffset, int offsetX, int offsetY) {
		Graphics g = getGraphics();

		if (g == null)
			return;
		/*try*/ {
			drawTile(g, i, j, erase,
				pressedOffset, offsetX, offsetY);
		/*} finally {
			g.dispose();*/
		}
	}

	private void drawBufferedTile(Graphics g, int i, int j, int pressedOffset,
			int tileI, int tileJ) {
		int dx, dy;
		int fillColor;

		dx = geo.cartesianX(i) + pressedOffset;
		dy = geo.cartesianY(j) + pressedOffset;
		if (geo.getReverse()) {
			fillColor = new Colour(geo.getBackground()).darker();
		} else {
			fillColor = geo.getTileColor();
		}
		if (pressedOffset != 0) {
			g.setColor(new Colour(fillColor).darker());
			drawShadow(g,
				dx - pressedOffset, dy - pressedOffset,
				geo.getTileSize().x, geo.getTileSize().y);
		}
		g.setColor(fillColor);
		fill3DRect(g, dx, dy, geo.getTileSize().x, geo.getTileSize().y,
			pressedOffset == 0);
		if (pressedOffset != 0) {
			g.fillRect(dx + geo.getTileSize().x - 2, dy - 1, 1, 3);
			g.fillRect(dx - 1, dy + geo.getTileSize().y - 2, 3, 1);
		}
		drawPyramid(g, tileI, i, j, tileJ, pressedOffset);
	}

	public void drawAllTiles() {
		int color, number;

		//model.printStacks();
		//model.printTiles();
		for (color = 0; color < model.getColors(); color++)
			for (number = 0; number < model.getTiles(); number++)
				drawTile(model.getColumnOfTile(color, number),
					model.getDepthOfTile(color, number),
					false, 0, 0, 0);
	}

	/*public void drawAllBufferedTiles() {
		int color, number, l;

		for (color = 0; color < model.getColors(); color++)
			for (number = 0; number < model.getTiles(); number++)
				for (l = 0; l < 2; l++)
					drawBufferedTile(
						bufferedStartGraphics[l],
						color, number, l);
	}

	public void getBuffers() {
		drawBuffer(bufferedStartGraphics[0], bufferedFrameImage);
		drawBuffer(bufferedStartGraphics[1], bufferedFrameImage);
		drawAllBufferedTiles();
		drawBuffer(bufferedFrameImage);
	}

	public void setBuffers(Canvas canvas) {
		bufferedFrameImage = canvas.createImage(geo.getCoreSize().x, geo.getCoreSize().y);
		bufferedFrameGraphics = bufferedFrameImage.getGraphics();
		bufferedStartImage[0] = canvas.createImage(geo.getCoreSize().x, geo.getCoreSize().y);
		bufferedStartImage[1] = canvas.createImage(geo.getCoreSize().x, geo.getCoreSize().y);
		bufferedStartGraphics[0] = bufferedStartImage[0].getGraphics();
		bufferedStartGraphics[1] = bufferedStartImage[1].getGraphics();
	}

	public void drawBuffer(Graphics g, Image i) {
		g.drawImage(i, 0, 0, geo.getCoreSize().x, geo.getCoreSize().y, canvas);
	}

	public void drawBuffer(Image i) {
		Graphics g = canvas.getGraphics();

		if (g == null)
			return;
		try {
			drawBuffer(g, i);
		} finally {
			g.dispose();
		}
	}*/

	private void drawSlots(Graphics g) {
		int i, dx, dy, y, sizex, sizey;
		boolean algorithme = (model.getMode() == PanexFormat.Modes.ALGORITHME.ordinal());
		boolean panex = (model.getMode() == PanexFormat.Modes.PANEX.ordinal());

		if (g == null)
			return;
		/*try*/ {
			sizex = geo.getTileSize().x / 3;
			sizey = geo.getTileSize().y / 3;
			if (sizey == 0)
				sizey = 1;
			dx = sizex + geo.getDelta().x + geo.getFrameOffset().x;
			y = model.getSlots() * geo.getPos().y + geo.getDelta().y;
			dy = geo.getDelta().y / 2 + geo.getFrameOffset().y + sizey;
			g.setColor(new Colour(geo.getBackground()).darker());
			g.fillRect((algorithme) ? 0 : dx, dy,
				(algorithme) ? (geo.getFrameSize().x - 2 * geo.getFrameOffset().x) :
					(sizex + (PanexFormat.MAX_COLUMNS - 1) * geo.getPos().x),
				sizey);
			if (panex || model.getTiles() != 1)
				for (i = 0; i < PanexFormat.MAX_COLUMNS; i++) {
					g.fillRect(dx, dy,
						sizex, y - 1 - 2 * sizey);
					dx += geo.getPos().x;
				}
		/*} finally {
			g.dispose();*/
		}
	}

	private void draw3DFrame(Graphics g, boolean inside,
			/*int x, int y,*/ int width, int height) {
		if (g == null)
			return;
		/*try*/ {
			if (inside)
				g.setColor(new Colour(geo.getBackground()).darker());
			else
				g.setColor(geo.getBackground());
			final int x = 0;
			final int y = 0;
			g.fillRect(x, y, width, 1);
			g.fillRect(x, y + 1, 1, height - 1);
			g.fillRect(x + 1, y + 1, width - 2, 1);
			g.fillRect(x + 1, y + 2, 1, height - 3);
			if (inside)
				g.setColor(new Colour(geo.getBackground()).brighter2());
			else
				g.setColor(geo.getBackground());
			g.fillRect(x + 1, y + height - 1, width - 1, 1);
			g.fillRect(x + width - 1, y + 1, 1, height - 2);
			g.fillRect(x + 2, y + height - 2, width - 3, 1);
			g.fillRect(x + width - 2, y + 2, 1, height - 4);
		/*} finally {
			g.dispose();*/
		}
	}

	private void drawFrame(Graphics g, boolean show, boolean border) {
		if (g == null)
			return;
		/*try*/ {
			int i, dx, dy, y, sizey;

			sizey = geo.getTileSize().y / 3;
			if (sizey == 0)
				sizey = 1;
			dx = geo.getTileSize().x / 3 + geo.getDelta().x + geo.getFrameOffset().x;
			y = model.getSlots() * geo.getPos().y + geo.getDelta().y;
			dy = geo.getDelta().y / 2 + geo.getFrameOffset().y + sizey;
			// TODO focus
			draw3DFrame(g, show/*&& focus*/, /*0, 0, */geo.getCoreSize().x, geo.getCoreSize().y);
			if (show) {
				if (!border) {
					g.setColor(new Colour(geo.getBackground()).darker());
					g.fillRect(dx, dy,
						geo.getTileSize().x / 3 + (PanexFormat.MAX_COLUMNS - 1) * geo.getPos().x,
						sizey);
					if ((model.getMode() != PanexFormat.Modes.ALGORITHME.ordinal()) ||
							model.getTiles() != 1)
						for (i = 0; i < PanexFormat.MAX_COLUMNS; i++) {
							g.fillRect(dx, dy, geo.getTileSize().x / 3,
								y - 1 - 2 * geo.getTileSize().y / 3);
							dx += geo.getPos().x;
						}
				}
			} else {
				g.setColor(geo.getBackground());
				g.fillRect(0, 0, geo.getCoreSize().x, geo.getCoreSize().y);
				g.fillRect(0, 0, 200, 200);
				//g.fillRect(geo.getFrameOffset().x, geo.getFrameOffset().y, x, y + 1);
			}
		/*} finally {
			g.dispose();*/
		}
	}
}
