package com.sillycycle.bagleyd.panex.view;

import android.content.Context;

//import com.sillycycle.bagleyd.util.Graphics;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.util.AttributeSet;
import android.view.View;

import com.sillycycle.bagleyd.panex.PanexCanvas;
import com.sillycycle.bagleyd.panex.model.PanexFormat;

/**
 *
 * @author <a href="mailto:bagleyd AT verizon.net">David Bagley</a>
 */

public class PanexView extends View {
	private static volatile PanexFormat model = null;
	private static volatile PanexGeometry geo = null;
	private static volatile PanexDraw aDraw = null;
	private static volatile PanexCanvas aCanvas = null;
	private static volatile Paint paint = null;

	/**
	 * @param context the rest of the application
	 */
	public PanexView(Context context) {
		super(context);
		setFocusableInTouchMode(true);
	}

	//FIXME
	public static boolean mainPanex(PanexCanvas canvas) { return true;}
	public static final void toggleSound(){}
	public void descriptionHelp(){}
	public void featuresHelp(){}
	public void referencesHelp(){}
	public void aboutHelp(){}
	public void quit(){}
	public void killDemoDialog() {}
	public void callbackPanex(PanexCanvas canvas, int ref) {}
	public void callbackPanex(PanexCanvas canvas, String string) {}
	public void showMessage(String string) {}
	public boolean getScript() {return false;}
	public boolean getToggleSound() {return false;}
	public void playBumpAudio() {}
	public void playDripAudio() {}
	public void playMoveAudio() {}

	/**
	 * @param context
	 * @param attrs
	 */
	public PanexView(Context context, AttributeSet attrs) {
		super(context, attrs);
		setFocusableInTouchMode(true);
	}

	/**
	 * @param context
	 * @param attrs
	 * @param defStyle
	 */
	public PanexView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		setFocusableInTouchMode(true);
	}

	/**
	 * @param canvas
	 */
	private void init(Canvas canvas) {
		if (model == null) {
			model = new PanexFormat(PanexFormat.defaultMode.ordinal(), PanexFormat.DEFAULT_TILES);
			geo = null;
		}
		if (geo == null || geo.getCoreSize().x != getWidth()) {
			geo = new PanexGeometry(model);
			geo.resize(getWidth(), getHeight());
			aDraw = null;
		}
		if (paint == null)
			paint = new Paint();
		aCanvas = new PanexCanvas(model, geo, canvas, paint, this);
		PanexCanvas.resizePuzzle();
		aDraw = PanexCanvas.getDraw();
		aCanvas.setPanexExtras();
	}

	// TODO suspect code
	public static PanexCanvas getPanexCanvas() {
		return aCanvas;
	}

	// Have to wait until an onDraw happens I guess
	/*public static PanexFormat getPanexFormat() {
		return model;
	}*/

	public static void focusReact(boolean hasFocus) {
		if (aCanvas != null)
			PanexCanvas.focusReact(hasFocus);
	}

	public void clearPanex() {
		if (aCanvas != null)
			aCanvas.clearPuzzle();
		invalidate();
	}

	public void decrementPanex() {
		if (aCanvas != null)
			aCanvas.decrementPuzzle();
		invalidate();
	}

	public void incrementPanex() {
		if (aCanvas != null)
			aCanvas.incrementPuzzle();
		invalidate();
	}

	public int undoPanex() {
		if (aCanvas != null) {
			aCanvas.undoPuzzle();
		}
		invalidate();
		return aCanvas.getMoves();
	}

	public int redoPanex() {
		if (aCanvas != null)
			aCanvas.redoPuzzle();
		invalidate();
		return aCanvas.getMoves();
	}

	public int solvePanex() {
		if (aCanvas != null)
			aCanvas.solvePuzzle();
		model.resetFormat(false);
		invalidate();
		return aCanvas.getMoves();
	}

	public static void changeFormatPanex(int mode) {
		if (aCanvas != null) {
			aCanvas.setPuzzleMode(mode);
		}
	}

	private void notifyTextChangeListener() {
		if (null != textChangeListener) {
			textChangeListener.onTextChange("");
		}
	}

	public interface TextChangeListener {
		void onTextChange(String string);
	}

	private TextChangeListener textChangeListener;

	public void setTextChangeListener(TextChangeListener listener) {
		textChangeListener = listener;
	}

	/**
	 * @see android.view.View#onDraw(android.graphics.Canvas)
	 */
	@Override
	protected void onDraw(Canvas canvas) {
		init(canvas);
		paint.setStyle(Style.STROKE);
		paint.setColor(hasFocus() ? Color.BLUE : Color.GRAY);
		//canvas.drawRect(0, 0, getWidth() - 1, getHeight() - 1, paint);
		//Graphics g = new Graphics(canvas, paint);
		aDraw.drawFrame(false, false);
		aDraw.drawFrame(true, false);
		aDraw.drawSlots();
		//drawAllBufferedTiles(g);
		aDraw.drawAllTiles();
		if (aCanvas != null) {
			aCanvas.setTileMoveListener(new PanexCanvas.TileMoveListener() {
				@Override public void onTileMove(PanexCanvas panexCanvas) {
					//String string = String.valueOf(aCanvas.getDigitString());
					notifyTextChangeListener();
					invalidate();
				}
			});
		}
	}
}
